
program ex_041;

uses
  Classes, SysUtils, BGRABitmap, BGRABitmapTypes;

{$R ex_001.res}

procedure Operations(image: TBGRABitmap);
const
  FICHIER = 'corot.jpg';
var
  texture, masque: TBGRABitmap;
begin
  texture := TBGRABitmap.Create(FICHIER);
  BGRAReplace(
    texture,
    //texture.Resample(100, 100)
    texture.GetPart(Rect(300, 300, 400, 400))
  );

  image.PutImage(0, 0, texture, dmDrawWithTransparency);

  masque := TBGRABitmap.Create(100, 100, BGRABlack);
  masque.FillEllipseAntialias(49.5, 49.5, 49.5, 49.5, BGRAWhite);

  image.PutImage(100, 0, masque, dmDrawWithTransparency);

  texture.ApplyMask(masque);

  image.PutImage(200, 0, texture, dmDrawWithTransparency);

  masque.Free;
  texture.Free;
end;

var
  image: TBGRABitmap;

begin
  image := TBGRABitmap.Create(300, 100, CSSGray);

  Operations(image);

  image.SaveToFile(ChangeFileExt(ParamStr(0), '.png'));
  image.Free;
end.
